package com.yhy.module.core.service.boq;

import com.yhy.module.core.controller.admin.boq.vo.BoqSubItemRespVO;
import com.yhy.module.core.controller.admin.boq.vo.BoqSubItemSaveReqVO;
import com.yhy.module.core.controller.admin.boq.vo.BoqSubItemSwapSortReqVO;

import javax.validation.Valid;
import java.util.List;

/**
 * 清单子项 Service 接口
 *
 * @author yhy
 */
public interface BoqSubItemService {

    /**
     * 创建清单子项
     *
     * @param createReqVO 创建信息
     * @return 子项ID
     */
    Long createBoqSubItem(@Valid BoqSubItemSaveReqVO createReqVO);

    /**
     * 更新清单子项
     *
     * @param updateReqVO 更新信息
     */
    void updateBoqSubItem(@Valid BoqSubItemSaveReqVO updateReqVO);

    /**
     * 删除清单子项
     *
     * @param id 子项ID
     */
    void deleteBoqSubItem(Long id);

    /**
     * 获取清单子项
     *
     * @param id 子项ID
     * @return 子项信息
     */
    BoqSubItemRespVO getBoqSubItem(Long id);

    /**
     * 获取清单子项列表
     *
     * @param boqItemTreeId 清单项树ID
     * @return 列表
     */
    List<BoqSubItemRespVO> getBoqSubItemList(Long boqItemTreeId);

    /**
     * 交换排序
     *
     * @param swapReqVO 交换信息
     */
    void swapSort(@Valid BoqSubItemSwapSortReqVO swapReqVO);
}
